加载中...
1588-所有奇数长度子数组的和(Sum of All Odd Length Subarrays)
发表于:2021-12-03 | 分类: 简单
字数统计: 1.5k | 阅读时长: 6分钟 | 阅读量:

原文链接: https://leetcode-cn.com/problems/sum-of-all-odd-length-subarrays

英文原文

Given an array of positive integers arr, calculate the sum of all possible odd-length subarrays.

A subarray is a contiguous subsequence of the array.

Return the sum of all odd-length subarrays of arr.

 

Example 1:

Input: arr = [1,4,2,5,3]
Output: 58
Explanation: The odd-length subarrays of arr and their sums are:
[1] = 1
[4] = 4
[2] = 2
[5] = 5
[3] = 3
[1,4,2] = 7
[4,2,5] = 11
[2,5,3] = 10
[1,4,2,5,3] = 15
If we add all these together we get 1 + 4 + 2 + 5 + 3 + 7 + 11 + 10 + 15 = 58

Example 2:

Input: arr = [1,2]
Output: 3
Explanation: There are only 2 subarrays of odd length, [1] and [2]. Their sum is 3.

Example 3:

Input: arr = [10,11,12]
Output: 66

 

Constraints:

  • 1 <= arr.length <= 100
  • 1 <= arr[i] <= 1000

中文题目

给你一个正整数数组 arr ,请你计算所有可能的奇数长度子数组的和。

子数组 定义为原数组中的一个连续子序列。

请你返回 arr 中 所有奇数长度子数组的和

 

示例 1:

输入:arr = [1,4,2,5,3]
输出:58
解释:所有奇数长度子数组和它们的和为:
[1] = 1
[4] = 4
[2] = 2
[5] = 5
[3] = 3
[1,4,2] = 7
[4,2,5] = 11
[2,5,3] = 10
[1,4,2,5,3] = 15
我们将所有值求和得到 1 + 4 + 2 + 5 + 3 + 7 + 11 + 10 + 15 = 58

示例 2:

输入:arr = [1,2]
输出:3
解释:总共只有 2 个长度为奇数的子数组,[1] 和 [2]。它们的和为 3 。

示例 3:

输入:arr = [10,11,12]
输出:66

 

提示:

  • 1 <= arr.length <= 100
  • 1 <= arr[i] <= 1000

通过代码

高赞题解

首先,力扣比赛第一题通常无脑暴力都能过。

我们只需要枚举所有的奇数长度的子数组即可。在下面的代码中,i 用来枚举每个连续子数组的起点,sz 为连续子数组的长度。accumulate用来计算起点是 i,长度为 sz 的子数组的和。时间复杂度是 O(n^3) 的。

我的参考代码(C++):

class Solution {
public:
    int sumOddLengthSubarrays(vector<int>& arr) {

        int res = 0;
        for(int i = 0; i < arr.size(); i ++)
            for(int sz = 1; i + sz - 1 < arr.size(); sz += 2)
                res += accumulate(arr.begin() + i, arr.begin() + i + sz, 0);
        return res;
    }
}; 

我的提交结果:时间 24ms;空间 8.2 MB。


在上面的解法中,accumulate的本质就是在计算从 arr[i]arr[i + sz - 1] 的连续子数组的和。计算连续子数组的和,很容想到可以使用前缀和(Prefix Sum)的方式。使用 O(n) 的时间可以预处理前缀和数组,之后使用 O(1) 的时间即可计算出一个连续子数组的和。

时间复杂度是 O(n^2) 的,空间复杂度是 O(n) 的。

我的参考代码(C++):

class Solution {
public:
    int sumOddLengthSubarrays(vector<int>& arr) {

        vector<int> presum = {0};
        for(int e: arr) presum.push_back(presum.back() + e);

        int res = 0;
        for(int i = 0; i < arr.size(); i ++)
            for(int sz = 1; i + sz - 1 < arr.size(); sz += 2)
                res += presum[i + sz] - presum[i];

        return res;
    }
};

我的提交结果:时间 8ms;空间 8.6 MB。


下面重点来了。这个问题有 O(n) 的解法。

其实想法很简单,相对也比较套路。就是遍历一遍所有的元素,然后查看这个元素会在多少个长度为奇数的数组中出现过。


比如题目给出的第一个测试用例 [1, 4, 2, 5, 3] 中;

1 在 3 个长度为奇数的数组中出现过:[1], [1, 4, 2], [1, 4, 2, 5, 3];所以最终的和,要加上 1 * 3;

4 在 4 个长度为奇数的数组中出现过:[4], [4, 2, 5], [1, 4, 2], [1, 4, 2, 5, 3];所以最终和,要加上 4 * 4;

2 在 5 个长度为奇数的数组中出现过:[2], [2, 5, 3], [4, 2, 5], [1, 4, 2], [1, 4, 2, 5, 3];所以最终和,要加上 5 * 2;

下面的关键就是,如何计算一个数字在多少个奇数长度的数组中出现过?


对于一个数字,它所在的数组,可以在它前面再选择 0, 1, 2, … 个数字,一共有 left = i + 1 个选择;

可以在它后面再选择 0, 1, 2, … 个数字,一共有 right = n - i 个选择。

如果在前面选择了偶数个数字,那么在后面,也必须选择偶数个数字,这样加上它自身,才构成奇数长度的数组;

如果在前面选择了奇数个数字,那么在后面,也必须选择奇数个数字,这样加上它自身,才构成奇数长度的数组;

数字前面共有 left 个选择,其中偶数个数字的选择方案有 left_even = (left + 1) / 2 个,奇数个数字的选择方案有 left_odd = left / 2 个;

数字后面共有 right 个选择,其中偶数个数字的选择方案有 right_even = (right + 1) / 2 个,奇数个数字的选择方案有 right_odd = right / 2 个;

所以,每个数字一共在 left_even * right_even + left_odd * right_odd 个奇数长度的数组中出现过。

我的参考代码(C++):

class Solution {
public:
    int sumOddLengthSubarrays(vector<int>& arr) {

        int res = 0;
        for(int i = 0; i < arr.size(); i ++){
            int left = i + 1, right = arr.size() - i,
                left_even = (left + 1) / 2, right_even = (right + 1) / 2,
                left_odd = left / 2, right_odd = right / 2;
            res += (left_even * right_even + left_odd * right_odd) * arr[i];
        }
        return res;
    }
};

我的提交结果:时间 4ms;空间 8 MB。

O(n) 的解法可以应对 10^6 乃至 10^7 的数字规模。如果这道题的数字规模是这样的,那么上面两种解法都将超时,这个问题也就变成了一个 Medium 甚至是 Hard 的问题了吧:)


觉得有帮助请点赞哇!



## 统计信息
| 通过次数 | 提交次数 | AC比率 |
| :------: | :------: | :------: |
|    44932    |    53552    |   83.9%   |

## 提交历史
| 提交时间 | 提交结果 | 执行时间 |  内存消耗  | 语言 |
| :------: | :------: | :------: | :--------: | :--------: |
上一篇:
1569-将子数组重新排序得到同一个二叉查找树的方案数(Number of Ways to Reorder Array to Get Same BST)
下一篇:
1589-所有排列中的最大和(Maximum Sum Obtained of Any Permutation)
本文目录
本文目录